.586
.model flat,stdcall
option casemap:none

WinMain PROTO   :DWORD,:DWORD,:DWORD,:DWORD
ConvertToASCII  PROTO   :DWORD,:DWORD
StringToNumber  PROTO   :DWORD
LocalCreateMenu PROTO   :DWORD
ToolbarProc     PROTO   :DWORD,:DWORD,:DWORD,:DWORD
LoadImageList    PROTO   :DWORD,:DWORD,:DWORD,:DWORD,:DWORD


include \masm32\include\windows.inc
include \masm32\include\kernel32.inc
include \masm32\include\user32.inc
include \masm32\include\comctl32.inc
include \masm32\include\gdi32.inc

includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\user32.lib
includelib \masm32\lib\comctl32.lib
includelib \masm32\lib\gdi32.lib

.const

MainWindowWidth         equ     800
MainWindowHeight        equ     700

; ++++ ListView Contants ++++

ID_ProcessName  equ     0
ID_ProcessID            equ   1 
ID_ParentProcessID      equ     5

; ++++ Menu Constants ++++

EnumerateID     equ     1
KillProcessID     equ     2
KillChildrenID    equ     3
KillParentID      equ      4
RefreshID         equ     5
ExitID               equ     6

SortAscendingID equ     7
SortDescendingID        equ     8

AboutID         equ     9

ReBarID         equ     0300h
ToolbarID       equ     0400h
Toolbar2ID      equ     0500h
ImgListID       equ     00h
ImgList2ID      equ     02h

.data

hInstance       DWORD           ?
CommandLine     LPSTR           ?

hMainWindow     dd              ?
MainWindowClass db              'MainWindowClass',0
MainWindowName  db              'Process Enumate&Kill',0

; ++++ List View related ++++

ListViewClass   db      'SysListView32',0            ; List view Class
hList           dd      ?                                  ; Handle to listview control

; ++++ Button Related ++++

ButtonClass     db      'BUTTON',0
hButton         dd      ?

; ++++ Static related ++++

StaticClass     db      'STATIC',0
hStatic         dd      ?

; ++++ Menu Related ++++

hMenu                dd              ?
hSubMenuAction  dd              ?
hSubMenuView    dd              ?
hSubMenuHelp     dd              ?
mii                     MENUITEMINFO            <>

ActionMenuString        db      'Action',0
ViewMenuString          db      'View',0
HelpMenuString          db      'Help',0

; Sub Menu Action

EnumerateString         db      'Enumerate',0
KillProcessString         db      'Kill Process',0
KillChildrenString        db     'Kill Child Processes',0
KillParentString           db     'Kill Parent Process',0
RefreshString             db     'Refresh List',0
ExitString                   db     'Exit ALT+F4',0

SortAscendingString     db      'Sort Ascending',0
SortDescendingString    db      'Sort Descending',0

AboutString                db       'About',0

; ++++ ReBar Related  +++++

hReBar          dd              ?
ReBarClass      db              'ReBarWindow32',0
rbbi            REBARBANDINFO      <>

; ++++ Toolbar Related ++++

; ++++ Bitmaps  ++++

; ++++ Toolbar execute ++++

hBmp            dd              ?

NoToolbarActionBitmaps  dd      6
ToolbarActionBitmaps   LABEL   DWORD
BtnEnum db      '.\btnenum.bmp',0
BtnEnumMask     db      '.\btnenumm.bmp',0
BtnKillProcess  db      '.\btnklprc.bmp',0
BtnKillProcessMask      db      '.\btnklprcm.bmp',0
BtnKillParent   db      '.\btnklpnt.bmp',0
BtnKillParentMask       db      '.\btnklpntm.bmp',0
BtnKillChild    db      '.\btnklcld.bmp',0
BtnKillChildMask        db      '.\btnklcldm.bmp',0
BtnRefresh      db      '.\btnrfrsh.bmp',0
BtnRefreshMask  db      '.\btnrfrshm.bmp',0
BtnQuit         db      '.\btnquit.bmp',0
BtnQuitMask     db      '.\btnquitm.bmp',0

; ++++ Toolbar View ++++

NoToolbarViewBitmaps    dd      2
ToolbarViewBitmaps      LABEL DWORD
BtnSortAscending        db      '.\btnsrta.bmp',0
BtnSortAscendingMask    db      '.\btnsrtam.bmp',0
BtnSortDescending       db      '.\btnsrtd.bmp',0
BtnSortDescendingMask   db      '.\btnsrtdm.bmp',0

hToolbar        dd              ?
ToolbarClass    db      'ToolbarWindow32',0
NoTBButtons     dd              8
TBButtons         TBBUTTON             <00h,01h,TBSTATE_ENABLED,BTNS_BUTTON,NULL,NULL>
                        TBBUTTON              <NULL,NULL,TBSTATE_ENABLED,TBSTYLE_SEP,NULL,NULL>
                       TBBUTTON             <01,02h,TBSTATE_ENABLED,BTNS_BUTTON,NULL,NULL>
                       TBBUTTON             <02,03h,TBSTATE_ENABLED,BTNS_BUTTON,NULL,NULL>
                       TBBUTTON             <03,04h,TBSTATE_ENABLED,BTNS_BUTTON,NULL,NULL>
                       TBBUTTON             <04,05h,TBSTATE_ENABLED,BTNS_BUTTON,NULL,NULL>
                       TBBUTTON             <NULL,NULL,TBSTATE_ENABLED,TBSTYLE_SEP,NULL,NULL>
                       TBBUTTON             <05,06h,TBSTATE_ENABLED,BTNS_BUTTON,NULL,NULL>
Execute         db      'Action',0

NoTBButtons2    dd      2

hToolbar2       dd              ?
TBButtons2       TBBUTTON            <00h,07h,TBSTATE_ENABLED,BTNS_BUTTON,NULL,NULL>
                       TBBUTTON            <01h,08h,TBSTATE_ENABLED,BTNS_BUTTON,NULL,NULL>
ViewString      db      'View',0
                       
; ++++ Other ++++

ProcessString              db      'Processes',0
ProcessIDString           db      'Process ID',0
HeapIDString               db      'Heap ID',0
ModuleIDString            db      'Module ID',0
ThreadsString              db      'Numer of Threads',0
ParentProcessIDString   db      'Parent Process ID',0
PriorityString               db      'Priority',0
HighPriorityString         db      'HIGH_PRIORITY_CLASS',0
IdlePriorityString          db      'IDLE_PRIORITY_CLASS',0
NormalPriorityString     db      'NORMAL_PRIORITY_CLASS',0
RealtimePriorityString   db      'REALTIME_PRIORITY_CLASS',0

Buffer                          db     8 dup('0'),'H',0
xlat_table                     db      '0123456789ABCDEF',0
pe32             PROCESSENTRY32                 <NULL>
iSubItem                     dd      0
rect                            RECT            <>
lvc                              LV_COLUMN       <>
lvi                              LV_ITEM	      <>
lvi2                            LV_ITEM         <>
hSnap                        dd              ?
PID                            dd              ?
hProcess                     dd      ?
TestString                    db        'Testing Kill',0
ENUM_FLAG               dd              FALSE
AlreadyEnumerated       db      'Already Enumerated',0
StringBuffer            db              256 dup(0)
ItemCount               dd              ?
ProcessNotTerminatedString      db      'One or more Process(es) couldnt be terminated',0
lpPrevProc      dd      ?
err             db      'Error adding bitmap',0
hImgList        dd      ?
hImgList2       dd      ?
NumBuffer       db      8 dup(0),'H',0
hParent         dd      	?
FirstItem       dd              ?
hImageList1     dd      ?
hImageList2     dd      ?
ThreadPriorityFlags     LABEL	DWORD
                      dd        THREAD_PRIORITY_ABOVE_NORMAL,offset szThreadProprityAboveNormal
                      dd        THREAD_PRIORITY_BELOW_NORMAL,offset szThreadPriorityBelowNormal
                      dd        THREAD_PRIORITY_HIGHEST,offset szThreadPriorityHighest
                      dd        THREAD_PRIORITY_IDLE,offset szThreadPriorityIdle
                      dd        THREAD_PRIORITY_LOWEST,offset szThreadPriorityLowest
                      dd        THREAD_PRIORITY_NORMAL,offset szThreadPriorityNormal
                      dd        THREAD_PRIORITY_TIME_CRITICAL,offset szThreadPriorityTimeCritical
szThreadProprityAboveNormal     db      'THREAD_PRIORITY_ABOVE_NORMAL',0
szThreadPriorityBelowNormal       db      'THREAD_PRIORITY_BELOW_NORMAL',0
szThreadPriorityHighest               db        'THREAD_PRIORITY_HIGHEST',0
szThreadPriorityIdle                    db      'THREAD_PRIORITY_IDLE',0
szThreadPriorityLowest               db         'THREAD_PRIORITY_LOWEST',0
szThreadPriorityNormal               db         'THREAD_PRIORITY_NORMAL',0
szThreadPriorityTimeCritical        db          'THREAD_PRIORITY_TIME_CRITICAL',0

.code
        start:
                invoke  GetModuleHandle,NULL    ;Get Current Process's handle
                mov     hInstance,eax                   ; and store it
                invoke  GetCommandLine          ; Get Command Line [ not really needed ]
                mov     CommandLine,eax         ; and store it
                invoke  InitCommonControls      ; Initialize common controls library
                invoke  WinMain,hInstance,NULL,CommandLine,SW_SHOWDEFAULT       
                invoke  ExitProcess,eax

WinMain PROC    hInst:DWORD,hPrevInst:DWORD,CmdLine:DWORD,CmdShow:DWORD

        local   wc:WNDCLASSEX
        local   msg:MSG

        mov     wc.cbSize,sizeof wc
        mov     wc.style,CS_HREDRAW+CS_VREDRAW
        mov     wc.lpfnWndProc,offset WndProc
        mov     wc.lpszMenuName,NULL
        mov     wc.lpszClassName,offset MainWindowClass
        mov     wc.cbClsExtra,NULL
        mov     wc.cbWndExtra,NULL
        mov     wc.hbrBackground,COLOR_WINDOW
        push    hInst
        pop     wc.hInstance
        invoke  LoadIcon,NULL,IDI_APPLICATION
        mov     wc.hIcon,eax
        mov     wc.hIconSm,eax
        invoke  LoadCursor,NULL,IDC_ARROW
        mov     wc.hCursor,eax
        invoke  RegisterClassEx,addr wc
        invoke  GetSystemMetrics,SM_CXSCREEN
        shr     eax,1
        sub     eax,MainWindowWidth/2
        push    eax
        invoke  GetSystemMetrics,SM_CYSCREEN
        shr     eax,1
        sub     eax,MainWindowHeight/2
        mov     ebx,eax
        pop     eax
        invoke  CreateWindowEx,NULL,addr MainWindowClass,addr MainWindowName,WS_TILEDWINDOW,\
                eax,ebx,MainWindowWidth,MainWindowHeight,NULL,NULL,hInstance,NULL
        mov     hMainWindow,eax
        invoke  ShowWindow,eax,SW_SHOWNORMAL
        invoke  UpdateWindow,hMainWindow

        .while  TRUE

                invoke  GetMessage,addr msg,NULL,0,0

        .break .if (!eax)

                invoke  TranslateMessage,addr msg
                invoke  DispatchMessage,addr msg

        .endw

        mov     eax,msg.wParam
        ret

WinMain endp

WndProc PROC    hWnd:DWORD,uMsg:DWORD,wParam:DWORD,lParam:DWORD
      
        .if     uMsg==WM_DESTROY

                invoke  PostQuitMessage,NULL
        .elseif uMsg==WM_CREATE 
                mov     edi,lParam
                assume  edi:PTR CREATESTRUCT

                .if     [lParam.CREATESTRUCT].hWndParent==NULL
                        invoke  LocalCreateMenu,hWnd
                        invoke  GetClientRect,hWnd,addr rect
                        invoke  CreateWindowEx,WS_EX_TOOLWINDOW,addr ReBarClass,NULL,WS_VISIBLE+WS_CHILD+\
                                           WS_CLIPCHILDREN+WS_CLIPSIBLINGS+CCS_NODIVIDER+RBS_AUTOSIZE,0,0,0,0,hWnd,NULL,hInstance,NULL
                        mov     hReBar,eax                  
                        invoke  CreateWindowEx,NULL,addr ToolbarClass,NULL,WS_VISIBLE+WS_CHILD+CCS_NORESIZE,\
                                           0,0,rect.right,32,hWnd,ToolbarID,hInstance,NULL                                                
                        mov     hToolbar,eax
                        invoke  LoadImageList,addr hImageList1,28,28,6,addr ToolbarActionBitmaps
                        invoke  SendMessage,hToolbar,TB_SETIMAGELIST,NULL,hImageList1
                        invoke  SendMessage,hToolbar,TB_BUTTONSTRUCTSIZE,sizeof TBBUTTON,0
                        invoke  SendMessage,hToolbar,TB_ADDBUTTONS,NoTBButtons,addr TBButtons
                        invoke  SendMessage,hToolbar,TB_AUTOSIZE,NULL,NULL

                       mov     rbbi.cbSize,sizeof rbbi
                       mov     rbbi.fMask,RBBIM_CHILD+RBBIM_SIZE+RBBIM_ID+RBBIM_CHILDSIZE+RBBIM_TEXT+RBBIM_STYLE
                       mov     rbbi.fStyle,RBBS_TOPALIGN+RBBS_GRIPPERALWAYS
                       push    hToolbar
                       pop     rbbi.hwndChild
                       mov     rbbi.cxMinChild,230
                       mov     rbbi.cyMinChild,38
                       mov     rbbi.cyChild,38
                       mov      rbbi.lx,230
                       mov     rbbi.lpText,offset Execute
                       mov     rbbi.cch,sizeof Execute
                       mov     rbbi.wID,ToolbarID
                       invoke  SendMessage,hReBar,RB_INSERTBAND,0,addr rbbi
                       invoke   CreateWindowEx,NULL,addr ToolbarClass,NULL,WS_VISIBLE+WS_CHILD+CCS_NORESIZE,\
                                        0,0,0,0,hWnd,Toolbar2ID,hInstance,NULL
                        mov     hToolbar2,eax
                        invoke  LoadImageList,addr hImageList2,28,28,NoToolbarViewBitmaps,addr ToolbarViewBitmaps
                        invoke  SendMessage,hToolbar2,TB_SETIMAGELIST,NULL,hImageList2
                        invoke  SendMessage,hToolbar2,TB_BUTTONSTRUCTSIZE,sizeof TBBUTTON,NULL
                        invoke  SendMessage,hToolbar2,TB_ADDBUTTONS,NoTBButtons2,addr TBButtons2
                        invoke  SendMessage,hToolbar2,TB_AUTOSIZE,NULL,NULL
                        push    hToolbar2
                        pop     rbbi.hwndChild
                        mov     rbbi.cxMinChild,72
                        mov     rbbi.cyMinChild,38
                        mov     rbbi.cyChild,38
                        mov     rbbi.lx,NULL
                        mov     rbbi.wID,Toolbar2ID
                        mov     rbbi.lpText,offset ViewString
                        invoke  SendMessage,hReBar,RB_INSERTBAND,1,addr rbbi              
                       push    rect.right
                       sub     rect.right,34
                       invoke  CreateWindowEx,WS_EX_STATICEDGE,addr StaticClass,NULL,WS_VISIBLE+WS_CHILD+SS_SIMPLE+SS_NOTIFY,\
                                                              0,32,rect.right,32,hWnd,NULL,hInstance,NULL
                       mov     hStatic,eax
                       pop     rect.right
                       push    rect.right
                       push    hStatic
                       pop     rbbi.hwndChild
                       sub     rect.right,210
                       push    rect.right
                       pop     rbbi.lx
                       mov     rbbi.cxMinChild,100
                       mov     rbbi.cyMinChild,38
                       mov     rbbi.lpText,offset StaticClass
                       mov     rbbi.wID,0
                       invoke  SendMessage,hReBar,RB_INSERTBAND,2,addr rbbi
                       invoke   SendMessage,hReBar,RB_SHOWBAND,1,TRUE
                       invoke  SendMessage,hReBar,RB_GETROWHEIGHT,0,0
                       add      eax,2
                       pop     rect.right
                       sub     rect.bottom,eax
                       invoke  CreateWindowEx,NULL,addr ListViewClass,NULL,WS_VISIBLE+WS_CHILD+LVS_REPORT,\
                                       0,eax,rect.right,rect.bottom,hWnd,0200h,hInstance,NULL
                       mov     hList,eax
                       invoke  SendMessage,hList,LVM_SETEXTENDEDLISTVIEWSTYLE,NULL,LVS_EX_GRIDLINES+LVS_EX_FULLROWSELECT ;+LVS_EX_ONECLICKACTIVATE
                       call     SetListView
 
               .endif
.elseif uMsg==WM_NOTIFY
        .if  [lParam.NMHDR].code==LVN_COLUMNCLICK
                .if [lParam.NM_LISTVIEW].iSubItem==0
                .endif
        .endif              
.elseif uMsg==WM_COMMAND

       invoke   ConvertToASCII,wParam,addr Buffer
       invoke   SendMessage,hStatic,WM_SETTEXT,NULL,addr Buffer
       mov      eax,wParam
               .if             ax==EnumerateID 
                 
                       call    Enumerate
                       
               .elseif         ax==KillProcessID

                       call    KillProcesses
                       
               .elseif          ax==KillChildrenID

                        call    KillChildren
                        
               .elseif         ax==KillParentID

                        call    KillParent
                        
               .elseif         ax==RefreshID

                       call    Refresh
                                                                            
               .elseif          ax==ExitID

                               invoke  PostQuitMessage,NULL
                               
               .endif
.else

               invoke  DefWindowProc,hWnd,uMsg,wParam,lParam
               ret

.endif

       xor     eax,eax
       ret

WndProc endp

KillProcesses   PROC

                               invoke  SendMessage,hList,LVM_GETITEMCOUNT,NULL,NULL
                               mov     ItemCount,eax
                               invoke  SendMessage,hList,LVM_GETSELECTIONMARK,NULL,NULL
                               push    eax
                               pop     lvi.iItem
                               mov     lvi.iSubItem,ID_ProcessID
                               mov     lvi.imask,LVIF_TEXT+LVIF_STATE+LVIF_PARAM
                               mov     lvi.stateMask,LVIS_SELECTED +LVIS_FOCUSED ;+LVIS_CUT+LVIS_DROPHILITED
                               mov     lvi.cchTextMax,256
                               mov     lvi.pszText,offset StringBuffer
killp_loop:                                
                               invoke  SendMessage,hList,LVM_GETITEM,NULL,addr lvi
                               test      lvi.state,LVIS_SELECTED ;+LVIS_FOCUSED
                               jz         next_item     
                               invoke  StringToNumber,offset StringBuffer
                               invoke  OpenProcess,PROCESS_TERMINATE,FALSE,PID
                               mov     hProcess,eax
                               invoke  TerminateProcess,hProcess,NULL
                                                                                               
                               .if     eax!=NULL
                                       invoke  SendMessage,hList,LVM_DELETEITEM,lvi.iItem,NULL
                                       invoke  CloseHandle,hProcess
                               .else
                                       invoke  SendMessage,hStatic,WM_SETTEXT,NULL,addr ProcessNotTerminatedString
                               .endif                                                                                
next_item:                                
                               inc       lvi.iItem
                               push    lvi.iItem
                               pop     eax
                               cmp     eax,ItemCount
                               jna      killp_loop

kp_skip:                                                  
                               mov     ENUM_FLAG,FALSE
                               ret
                               
KillProcesses   endp

KillChildren    PROC
        
        invoke  SendMessage,hList,LVM_GETITEMCOUNT,NULL,NULL
        mov     ItemCount,eax
        invoke  SendMessage,hList,LVM_GETSELECTIONMARK,NULL,NULL
        mov     FirstItem,eax
        cmp     eax,-1
        je        end_kc   
        mov     lvi.imask,LVIF_TEXT+LVIF_STATE
        mov     lvi.stateMask,LVIS_SELECTED
        mov     lvi.pszText,offset StringBuffer
        mov     lvi.cchTextMax,sizeof StringBuffer
loop_1:
        push    FirstItem
        pop     lvi.iItem
        mov     lvi.iSubItem,ID_ProcessID
        invoke  SendMessage,hList,LVM_GETITEM,NULL,addr lvi
        invoke  StringToNumber,lvi.pszText
        push    PID
        pop     hParent
        test    lvi.state,LVIS_SELECTED
        jnz     scan_sub_items
        inc     FirstItem
        mov     eax,ItemCount
        cmp     FirstItem,eax
        ja      end_kc
        jmp     loop_1
scan_sub_items:
        mov     lvi.iItem,0
        mov     lvi.iSubItem,ID_ParentProcessID
loop_2:
        invoke  SendMessage,hList,LVM_GETITEM,NULL,addr lvi
        invoke  StringToNumber,lvi.pszText
        mov     eax,hParent
        cmp     PID,eax
        jne     next_child_item
        push    lvi.iSubItem
        mov     lvi.iSubItem,ID_ProcessID
        invoke  SendMessage,hList,LVM_GETITEM,NULL,addr lvi
        invoke  StringToNumber,lvi.pszText
        invoke  OpenProcess,PROCESS_TERMINATE,FALSE,PID
        push    eax
        invoke  TerminateProcess,eax,NULL
        pop     eax
        invoke  CloseHandle,eax
        pop     lvi.iSubItem
        cmp     eax,NULL
        je       next_item
        invoke  SendMessage,hList,LVM_DELETEITEM,lvi.iItem,NULL
next_child_item:
        mov     eax,ItemCount
        cmp     lvi.iItem,eax
        je      next_item
        inc     lvi.iItem
        jmp     loop_2
next_item:        
        inc     FirstItem
        cmp     FirstItem,eax
        jna     loop_1
end_kc:        
        ret

KillChildren    endp

KillParent      PROC

        invoke  SendMessage,hList,LVM_GETITEMCOUNT,NULL,NULL
        mov     ItemCount,eax
        invoke  SendMessage,hList,LVM_GETSELECTIONMARK,NULL,NULL
        mov     FirstItem,eax
        cmp     eax,-1
        je       end_kp
        mov     lvi.imask,LVIF_TEXT+LVIF_STATE
        mov     lvi.stateMask,LVIS_SELECTED
        mov     lvi.pszText,offset StringBuffer
        mov     lvi.cchTextMax,256
loop_1:
        push    FirstItem
        pop     lvi.iItem
        mov     lvi.iSubItem,ID_ParentProcessID
        invoke  SendMessage,hList,LVM_GETITEM,NULL,addr lvi
        invoke  StringToNumber,lvi.pszText
        push    PID
        pop     hParent        
        test    lvi.state,LVIS_SELECTED
        jnz      scan_for_parent_process
        inc     FirstItem
        mov     eax,ItemCount
        cmp     FirstItem,eax
        ja      end_kp
        jmp     loop_1
scan_for_parent_process:
        mov     lvi.iItem,0
        mov     lvi.iSubItem,ID_ProcessID        
loop_2:
        invoke  SendMessage,hList,LVM_GETITEM,NULL,addr lvi
        invoke  StringToNumber,lvi.pszText
        mov     eax,hParent
        cmp     eax,PID
        jne     next_item
        invoke  OpenProcess,PROCESS_TERMINATE,FALSE,PID
        push    eax
        invoke  TerminateProcess,eax,NULL
        pop     eax
        invoke  CloseHandle,eax
        invoke  SendMessage,hList,LVM_DELETEITEM,lvi.iItem,NULL
next_item:        
        inc     lvi.iItem
        mov     eax,ItemCount
        cmp     lvi.iItem,eax
        jna     loop_2
        inc     FirstItem
        cmp     FirstItem,eax
        jna     loop_1
end_kp:
        invoke  ConvertToASCII,eax,addr Buffer
        invoke  SendMessage,hStatic,WM_SETTEXT,NULL,addr Buffer
        ret

KillParent      endp

Refresh         PROC

                        cmp     ENUM_FLAG,FALSE
                        je      end_refresh
                       invoke  SendMessage,hStatic,WM_SETTEXT,NULL,addr TestString
                       invoke        SendMessage,hList,LVM_DELETEALLITEMS,NULL,NULL
                       mov           ENUM_FLAG,FALSE
                       call            Enumerate
end_refresh:                       
                       ret

Refresh         endp

SetListView     PROC

                       mov     lvc.imask,LVCF_FMT+LVCF_WIDTH+LVCF_TEXT
                       mov     lvc.fmt,LVCFMT_LEFT
                       push    rect.right
                       pop     lvc.lx
                       shr      lvc.lx,2
                       mov     lvc.pszText,offset ProcessString
                       invoke  SendMessage,hList,LVM_INSERTCOLUMN,ID_ProcessName,addr lvc 
                       shr     lvc.lx,1
                       mov     lvc.pszText,offset ProcessIDString
                       invoke  SendMessage,hList,LVM_INSERTCOLUMN,ID_ProcessID,addr lvc
                       mov     lvc.pszText,offset HeapIDString
                       invoke  SendMessage,hList,LVM_INSERTCOLUMN,2,addr lvc
                       mov     lvc.pszText,offset ModuleIDString
                       invoke  SendMessage,hList,LVM_INSERTCOLUMN,3,addr lvc
                       mov     lvc.pszText,offset ThreadsString
                       invoke  SendMessage,hList,LVM_INSERTCOLUMN,4,addr lvc
                       mov     lvc.pszText,offset ParentProcessIDString
                       invoke  SendMessage,hList,LVM_INSERTCOLUMN,5,addr lvc
                       mov     lvc.pszText,offset PriorityString
                       invoke  SendMessage,hList,LVM_INSERTCOLUMN,6,addr lvc
                       ret

SetListView     endp

Enumerate       PROC

                       cmp     ENUM_FLAG,TRUE
                       jne      enum
                       invoke        SendMessage,hStatic,WM_SETTEXT,NULL,addr AlreadyEnumerated
                       jmp     ender
enum:                                  

                       invoke  CreateToolhelp32Snapshot,TH32CS_SNAPALL,NULL
                       mov     hSnap,eax
                       mov     pe32.dwSize,sizeof PROCESSENTRY32
                       invoke  Process32First,hSnap,addr pe32

                       mov     lvi.imask,LVIF_TEXT; +LVIF_PARAM
                       mov     lvi.iItem,0    
                       mov     lvi.iSubItem,0
                       push     lvi.iItem
                       pop      lvi.lParam
                       push    offset pe32.szExeFile
                       pop     lvi.pszText
                       invoke  SendMessage,hList,LVM_INSERTITEM,0,addr lvi   
                       inc     lvi.iSubItem
                       invoke  ConvertToASCII,pe32.th32ProcessID,addr Buffer                    
                       mov     lvi.pszText,offset Buffer
                       invoke  SendMessage,hList,LVM_SETITEM,0,addr lvi
                       inc     lvi.iSubItem
                       invoke  ConvertToASCII,pe32.th32DefaultHeapID,addr Buffer
                       invoke  SendMessage,hList,LVM_SETITEM,0,addr lvi
                       
                       inc     lvi.iSubItem
                       invoke  ConvertToASCII,pe32.th32ModuleID,addr Buffer
                       invoke  SendMessage,hList,LVM_SETITEM,0,addr lvi
                       inc     lvi.iSubItem
                       invoke  ConvertToASCII,pe32.cntThreads,addr Buffer
                       invoke  SendMessage,hList,LVM_SETITEM,0,addr lvi
                       inc     lvi.iSubItem

                       mov     ecx,7
                       mov     eax,pe32.pcPriClassBase
                       lea      edi,ThreadPriorityFlags
thread_pri_loop:                        
                       cmp     eax,dword ptr [edi]
                       je       tp_next
                       add      edi,4
                       dec      ecx
                       jcxz     skip1
                       jmp      thread_pri_loop
tp_next:
                        add     edi,4
                        push    dword ptr [edi]
                        pop     lvi.pszText
                        jmp     skip2
skip1:                                                                                                               
                       invoke  ConvertToASCII,pe32.pcPriClassBase,addr Buffer
                       mov      lvi.pszText,offset Buffer
skip2:           
                       invoke  SendMessage,hList,LVM_SETITEM,0,addr lvi
                       inc     lvi.iItem          
                                      

looper:
                        push    lvi.iItem
                        pop     lvi.lParam
                       mov     lvi.iSubItem,0
                       mov     lvi.pszText,offset pe32.szExeFile
                       invoke  Process32Next,hSnap,addr pe32
                       cmp     eax,NULL 
                       je        end_looper
                       invoke  SendMessage,hList,LVM_INSERTITEM,NULL,addr lvi
                       inc     lvi.iSubItem
                       push    pe32.th32ProcessID
                       pop     lvi.lParam
                       invoke  ConvertToASCII,pe32.th32ProcessID,addr Buffer
                       mov     lvi.pszText,offset Buffer
                       invoke  SendMessage,hList,LVM_SETITEM,0,addr lvi
                       inc     lvi.iSubItem
                       invoke  ConvertToASCII,pe32.th32DefaultHeapID,addr Buffer
                       invoke  SendMessage,hList,LVM_SETITEM,0,addr lvi

                       inc     lvi.iSubItem
                       invoke  ConvertToASCII,pe32.th32ModuleID,addr Buffer
                       invoke  SendMessage,hList,LVM_SETITEM,0,addr lvi
                       inc     lvi.iSubItem
                       invoke  ConvertToASCII,pe32.cntThreads,addr Buffer
                       invoke  SendMessage,hList,LVM_SETITEM,0,addr lvi
                       inc     lvi.iSubItem
                       invoke  ConvertToASCII,pe32.th32ParentProcessID,addr Buffer
                       invoke  SendMessage,hList,LVM_SETITEM,0,addr lvi
                       inc     lvi.iSubItem
                       mov     eax,pe32.pcPriClassBase
                       lea      edi,ThreadPriorityFlags
                       mov      ecx,7
tp_loop_2:
                        cmp     eax,dword ptr [edi]
                       je       tp2_next
                       add      edi,4
                       dec      ecx
                       jcxz     skip3
                       jmp      tp_loop_2
tp2_next:
                        add     edi,4
                        push    dword ptr [edi] 
                        pop     lvi.pszText
                        jmp     skip4                        
skip3:                       
                       invoke  ConvertToASCII,pe32.pcPriClassBase,addr Buffer
                       mov      lvi.pszText,offset Buffer
skip4:                       
                       invoke  SendMessage,hList,LVM_SETITEM,0,addr lvi

                       
                       inc     lvi.iItem                                
                       jmp     looper
end_set_flag:
                       mov     ENUM_FLAG,FALSE
                       jmp     ender                       
end_looper:
                       invoke  CloseHandle,hSnap
                       mov     ENUM_FLAG,TRUE
ender:                        
                       ret
Enumerate     endp

ConvertToASCII  PROC    val:DWORD,lpBuffer:DWORD

               push    eax
               push    ebx
               push    edx
               push    ecx                        
               pushfd  
               cld                                    
               mov     edi,lpBuffer
               push    edi
               mov      eax,'0000'
               stosd
               stosd
               pop     edi                                           
               mov     eax,val
               mov     ebx,010h                        
               add     edi,7
               std
looper:
               xor     edx,edx
               div     ebx
               cmp      eax,0
               je      end_looper
               push    eax
               push    ebx
               mov     al,dl
               lea     ebx,xlat_table
               xlat    
               stosb
               pop     ebx
               pop     eax
               jmp     looper
end_looper:
               mov     al,dl
               lea     ebx,xlat_table
               xlat
               stosb
               popfd
               pop     ecx
               pop     edx
               pop     ebx
               pop     eax                                                                                                
               ret

ConvertToASCII  endp

StringToNumber       PROC    lpSource:DWORD

               local   Multiplied:DWORD

               pushad
               pushfd                                                        
               mov     esi,lpSource
               mov     ecx,7
               xor     eax,eax
               xor     edx,edx
               mov     ebx,010h
               mov     Multiplied,0
               cld
loop_0:                
               lodsb
               cmp     al,39h
               ja      abc_char
               sub     al,30h
               jmp     jmp_0
abc_char:              
               cmp     al,48h
               ja       no_caps
               sub     al,55
               jmp     jmp_0
no_caps:      
               sub     al,57h
jmp_0:                
               movzx   eax,al
               add     eax,Multiplied
               cmp     ecx,0
               je      end_loop_0
               xor     edx,edx
               mul     ebx
               mov     Multiplied,eax  
               dec     ecx                                                                                     
               jmp     loop_0
end_loop_0:       
               mov     PID,eax         
               popfd
               popad
               ret

StringToNumber          endp

LocalCreateMenu PROC    hWnd:DWORD

       
               invoke  CreateMenu
               mov     hMenu,eax
               invoke  SetMenu,hWnd,eax
               
               invoke  CreatePopupMenu
               mov     hSubMenuAction,eax
               invoke  CreatePopupMenu
               mov     hSubMenuView,eax
               invoke  CreatePopupMenu
               mov     hSubMenuHelp,eax

; Set The SubMenus

               mov     mii.cbSize,sizeof mii
               mov     mii.fMask,MIIM_TYPE+MIIM_ID+MIIM_SUBMENU
               mov     mii.fType,MFT_STRING
               mov     mii.dwTypeData,offset ActionMenuString
               push    hSubMenuAction
               pop     mii.hSubMenu
               invoke  InsertMenuItem,hMenu,0100h,TRUE,addr mii
               push    hSubMenuView
               pop     mii.hSubMenu
               mov     mii.dwTypeData,offset ViewMenuString
               invoke  InsertMenuItem,hMenu,0200h,TRUE,addr mii
               push    hSubMenuHelp
               pop     mii.hSubMenu
               mov     mii.dwTypeData,offset HelpMenuString
               invoke  InsertMenuItem,hMenu,0300h,TRUE,addr mii
               
; Set the action submenu's items

               mov     mii.hSubMenu,NULL
               mov     mii.dwTypeData,offset EnumerateString
               mov     mii.wID, EnumerateID
               invoke  InsertMenuItem,hSubMenuAction,1,FALSE,addr mii
               push    mii.fType
               mov     mii.fType,MFT_SEPARATOR
               mov     mii.wID,NULL
               invoke  InsertMenuItem,hSubMenuAction,2,FALSE,addr mii
               pop     mii.fType
               mov     mii.wID,KillProcessID
               mov     mii.dwTypeData,offset KillProcessString
               invoke  InsertMenuItem,hSubMenuAction,3,FALSE,addr mii
               mov     mii.wID,KillChildrenID
               mov     mii.dwTypeData,offset KillChildrenString
               invoke  InsertMenuItem,hSubMenuAction,4,FALSE,addr mii
               mov     mii.wID,KillParentID
               mov     mii.dwTypeData,offset KillParentString
               invoke  InsertMenuItem,hSubMenuAction,5,FALSE,addr mii
               mov     mii.wID,RefreshID
               mov     mii.dwTypeData,offset RefreshString
               invoke  InsertMenuItem,hSubMenuAction,6,FALSE,addr mii
               mov     mii.wID,NULL
               push    mii.fType
               mov     mii.fType,MFT_SEPARATOR
               invoke  InsertMenuItem,hSubMenuAction,7,FALSE,addr mii
               pop     mii.fType
               mov     mii.wID,ExitID
               mov     mii.dwTypeData,offset ExitString
               invoke  InsertMenuItem,hSubMenuAction,8,FALSE,addr mii

; Set the View Submenu's items

               mov     mii.dwTypeData,offset SortAscendingString
               mov     mii.wID,SortAscendingID
               invoke  InsertMenuItem,hSubMenuView,1,FALSE,addr mii
               mov     mii.dwTypeData,offset SortDescendingString
               mov     mii.wID,SortDescendingID
               invoke  InsertMenuItem,hSubMenuView,2,FALSE,addr mii

; Set the help Submenu's items

               mov     mii.dwTypeData,offset AboutString
               mov     mii.wID,AboutID
               invoke  InsertMenuItem,hSubMenuHelp,1,FALSE,addr mii

; Draw the bar

               invoke  DrawMenuBar,hWnd
               ret
               
LocalCreateMenu endp

LoadImageList   PROC    hImageList:DWORD,cxBmp:DWORD,cyBmp:DWORD,NoBitmaps:DWORD,lpszBitmapsSpec:DWORD

        local   count:DWORD

        mov     esi,hImageList                
        invoke  ImageList_Create,cxBmp,cyBmp,ILC_COLOR16+ILC_MASK,NoBitmaps,NoBitmaps
        mov     dword ptr [esi],eax
        mov     edi,lpszBitmapsSpec
        mov     ecx,NoBitmaps
        cld
loop_0:
        push    ecx
        invoke  LoadImage,hInstance,edi,IMAGE_BITMAP,cxBmp,cyBmp,LR_LOADFROMFILE
        mov     hBmp,eax
sub_loop_0:
        cmp     byte ptr [edi],0
        je      load_mask
        inc     edi
        jmp     sub_loop_0
load_mask:        
        inc     edi
        invoke  LoadImage,hInstance,edi,IMAGE_BITMAP,cxBmp,cyBmp,LR_LOADFROMFILE
        push    eax
        invoke  ImageList_Add,dword ptr [esi],hBmp,eax
        pop     eax
        invoke  DeleteObject,eax
        invoke  DeleteObject,hBmp
sub_loop_1:
        cmp     byte ptr [edi],0        
        je      load_bmp
        inc     edi
        jmp     sub_loop_1
load_bmp:
        inc     edi
        pop     ecx
        dec     ecx
        jcxz    end_lil
        jmp     loop_0
end_lil:
        ret

LoadImageList   endp            

ClearBuffer     PROC

        push    eax
        push    edi
        pushfd
        lea     edi,Buffer
        xor     eax,eax
        stosd
        stosd
        stosw
        popfd
        pop     edi
        pop     eax
        ret
ClearBuffer     endp        
                                    
                
end     start                                      
